"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/dom-query.ts
var dom_query_exports = {};
__export(dom_query_exports, {
  getSelector: () => getSelector
});
module.exports = __toCommonJS(dom_query_exports);
function getSelector(node) {
  const id = node.getAttribute("id");
  if (id)
    return "#" + id;
  let path = "";
  while (node) {
    let name = node.localName;
    const parent = node.parentNode;
    if (!parent) {
      path = name + " > " + path;
      continue;
    }
    if (node.getAttribute("id")) {
      path = "#" + node.getAttribute("id") + " > " + path;
      break;
    }
    const sameTagSiblings = [];
    let children = parent.childNodes;
    children = Array.prototype.slice.call(children);
    children.forEach((child) => {
      if (child.localName == name) {
        sameTagSiblings.push(child);
      }
    });
    if (sameTagSiblings.length > 1) {
      const index = sameTagSiblings.indexOf(node);
      name += ":nth-of-type(" + (index + 1) + ")";
    }
    if (path) {
      path = name + " > " + path;
    } else {
      path = name;
    }
    node = parent;
  }
  return path;
}
__name(getSelector, "getSelector");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getSelector
});
