"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/dom.ts
var dom_exports = {};
__export(dom_exports, {
  contains: () => contains,
  defaultDocument: () => defaultDocument,
  defaultLocation: () => defaultLocation,
  defaultNavigator: () => defaultNavigator,
  defaultWindow: () => defaultWindow,
  sortByDomNode: () => sortByDomNode,
  unrefElement: () => unrefElement,
  useDebouncedRef: () => useDebouncedRef,
  useRef: () => useRef
});
module.exports = __toCommonJS(dom_exports);
var import_vue = require("vue");

// src/timers.ts
function debounce(func, wait, immediate) {
  let timeout;
  return (...args) => {
    if (immediate && !timeout)
      func(...args);
    clearTimeout(timeout);
    timeout = setTimeout(() => {
      func(...args);
    }, wait);
  };
}
__name(debounce, "debounce");

// src/dom.ts
var import_utils = require("@chakra-ui/utils");
function useRef() {
  const refEl = (0, import_vue.ref)(null);
  (0, import_vue.onBeforeUpdate)(() => {
    refEl.value = null;
  });
  const _ref = /* @__PURE__ */ __name((el) => {
    var _a;
    refEl.value = (_a = el == null ? void 0 : el.$el) != null ? _a : el;
  }, "_ref");
  return [_ref, refEl];
}
__name(useRef, "useRef");
function unrefElement(elementRef) {
  var _a;
  const node = (0, import_vue.unref)(elementRef);
  return (_a = node == null ? void 0 : node.$el) != null ? _a : node;
}
__name(unrefElement, "unrefElement");
function useDebouncedRef(initialValue, delay = 300, immediate = false) {
  const state = (0, import_vue.ref)(initialValue);
  const debouncedRef = (0, import_vue.customRef)((track, trigger) => ({
    get() {
      track();
      return state.value;
    },
    set: debounce((value) => {
      state.value = value;
      trigger();
    }, delay, immediate)
  }));
  return debouncedRef;
}
__name(useDebouncedRef, "useDebouncedRef");
function contains(containers, element) {
  for (let container of containers) {
    if (container.contains(element))
      return true;
  }
  return false;
}
__name(contains, "contains");
var defaultWindow = /* @__PURE__ */ (0, import_utils.canUseDOM)() ? window : void 0;
var defaultDocument = /* @__PURE__ */ (0, import_utils.canUseDOM)() ? window.document : void 0;
var defaultNavigator = /* @__PURE__ */ (0, import_utils.canUseDOM)() ? window.navigator : void 0;
var defaultLocation = /* @__PURE__ */ (0, import_utils.canUseDOM)() ? window.location : void 0;
function sortByDomNode(nodes, resolveKey = (i) => i) {
  return nodes.slice().sort((aItem, zItem) => {
    let a = resolveKey(aItem);
    let z = resolveKey(zItem);
    if (a === null || z === null)
      return 0;
    let position = a.compareDocumentPosition(z);
    if (position & Node.DOCUMENT_POSITION_FOLLOWING)
      return -1;
    if (position & Node.DOCUMENT_POSITION_PRECEDING)
      return 1;
    return 0;
  });
}
__name(sortByDomNode, "sortByDomNode");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  contains,
  defaultDocument,
  defaultLocation,
  defaultNavigator,
  defaultWindow,
  sortByDomNode,
  unrefElement,
  useDebouncedRef,
  useRef
});
