"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/vue-utils.ts
var vue_utils_exports = {};
__export(vue_utils_exports, {
  createContext: () => createContext,
  getValidChildren: () => getValidChildren,
  isObjectComponent: () => isObjectComponent,
  resolveRef: () => resolveRef,
  transformComposableProps: () => transformComposableProps,
  withSingleton: () => withSingleton
});
module.exports = __toCommonJS(vue_utils_exports);
var import_utils = require("@chakra-ui/utils");
var import_vue = require("vue");
function createContext(options = {}, defaults) {
  const {
    strict = true,
    errorMessage = "useContext: `context` is undefined. Seems you forgot to wrap component within the Provider",
    name
  } = options;
  let contextSymbol = Symbol(`${name}Symbol`);
  function Provider(payload) {
    (0, import_vue.provide)(contextSymbol, payload);
  }
  __name(Provider, "Provider");
  function useContext(fallback = null) {
    const context = (0, import_vue.inject)(contextSymbol, fallback);
    if (!context && strict) {
      throw new Error(errorMessage);
    }
    return context;
  }
  __name(useContext, "useContext");
  return [Provider, useContext, contextSymbol];
}
__name(createContext, "createContext");
function getValidChildren(slots) {
  var _a;
  const slotArray = ((_a = slots == null ? void 0 : slots.default) == null ? void 0 : _a.call(slots)) || [];
  return slotArray.filter((child) => {
    return (0, import_vue.isVNode)(child);
  });
}
__name(getValidChildren, "getValidChildren");
function withSingleton(slots, componentName, props) {
  const validChildren = getValidChildren(slots);
  if (validChildren.length > 1) {
    const errorMessage = `[${componentName}] : ${componentName} can only have one root element.`;
    console.error(errorMessage);
    throw new SyntaxError(errorMessage);
  }
  const finalSlot = (0, import_vue.cloneVNode)(validChildren[0]);
  return (0, import_vue.h)(finalSlot, props);
}
__name(withSingleton, "withSingleton");
function transformComposableProps(props) {
  return {
    ...props,
    context: (0, import_vue.reactive)(props.context)
  };
}
__name(transformComposableProps, "transformComposableProps");
function isObjectComponent(subject) {
  const validComponentTypes = ["function", "object"];
  if (!validComponentTypes.includes(typeof subject))
    return false;
  if ((0, import_utils.isObject)(subject)) {
    if (typeof (subject == null ? void 0 : subject.render) === "function" && (0, import_vue.isVNode)(subject.render()))
      return true;
    else if (typeof (subject == null ? void 0 : subject.setup) === "function")
      return true;
  }
  return false;
}
__name(isObjectComponent, "isObjectComponent");
function resolveRef(r) {
  return typeof r === "function" ? (0, import_vue.computed)(r) : (0, import_vue.ref)(r);
}
__name(resolveRef, "resolveRef");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createContext,
  getValidChildren,
  isObjectComponent,
  resolveRef,
  transformComposableProps,
  withSingleton
});
